#ifndef CAMERA_H
#define CAMERA_H
#include "vec4.h"
#include "defines.h"
#include <GL/glut.h>

class Camera{
public:
	static const float initJumpSpeed;
	static const float gravity;
	static const float groundHeight;
	static const float moveSpeed;
	vec4d eye;
	vec4d lookAt;
	vec4d up;
	vec4d speed;
	unsigned int moveState;
	bool isJumping;

	Camera();
	~Camera();
	void rotate(float dX, float dY);
	void jump();
	void update(int msDelta);
	void draw();

private:
	GLfloat xzAngle;
	static const float incX;					
	static const float incY;
};

#endif //CAMERA_H