#include "Ground.h"
#include "mat4.h"

Ground::Ground(){
	size = 300.0f;
}
Ground::~Ground(){}

void Ground::setup(GLuint displayIndex, GLuint textures[]){
	Drawable::setup(displayIndex, textures);
	glNewList(displayIndex + GROUND_LIST, GL_COMPILE);
	glColor4f(1.0f, 1.0f, 1.0f, 0.4f);
	glMaterialfv(GL_FRONT, GL_SPECULAR, vec4f(.0f,.0f,.0f,1.0f));
	glBindTexture(GL_TEXTURE_2D, textures[GROUND_TEXTURE]);
	glBegin(GL_QUADS);
		glNormal3f(0.0f, 1.0f, 0.0f);
		glTexCoord2f(0.0f, 0.0f);
		glVertex3f(-size, 0.0f, -size);
		glTexCoord2f(0.0f, 10.0f);
		glVertex3f(-size, 0.0f, size);
		glTexCoord2f(10.0f, 10.0f);
		glVertex3f(size, 0.0f, size);
		glTexCoord2f(10.0f, 0.0f);
		glVertex3f(size, 0.0f, -size);
	glEnd();
	glEndList();
}

void Ground::update(int msDelta){}

void Ground::draw(){
	glPushMatrix();
		glTranslatef(position.x, position.y, position.z);
		glCallList(displayIndex + GROUND_LIST);
	glPopMatrix();
}

float Ground::getSize(){return size;}