#include "Skybox.h"

Skybox::Skybox(){}
Skybox::~Skybox(){}

void Skybox::setup(GLuint displayIndex, GLuint textures[]){
	Drawable::setup(displayIndex, textures);
	GLfloat size = 5.0f;
	glNewList(displayIndex + SKYBOX_LIST, GL_COMPILE);
		//Front
		glBindTexture(GL_TEXTURE_2D, textures[NEG_Z]);
		glBegin(GL_QUADS);
			glTexCoord2f(0.001f, .999f);
			glVertex3f(-size, -size, -size);
			glTexCoord2f(.999f, .999f);
			glVertex3f(size, -size, -size);
			glTexCoord2f(.999f, 0.001f);
			glVertex3f(size, size, -size);
			glTexCoord2f(0.001f, 0.001f);
			glVertex3f(-size, size, -size);
		glEnd();

		//Back	
		glBindTexture(GL_TEXTURE_2D, textures[POS_Z]);
		glBegin(GL_QUADS);
			glTexCoord2f(.999f, 0.001f);
			glVertex3f(-size, size, size);
			glTexCoord2f(0.001f, 0.001f);
			glVertex3f(size, size, size);
			glTexCoord2f(0.001f, .999f);
			glVertex3f(size, -size, size);
			glTexCoord2f(.999f, .999f);
			glVertex3f(-size, -size, size);
		glEnd();

		//Bottom
		glBindTexture(GL_TEXTURE_2D, textures[NEG_Y]);
		glBegin(GL_QUADS);
			glTexCoord2f(.999f, .999f);
			glVertex3f(size, -size, -size);
			glTexCoord2f(.999f, 0.001f);
			glVertex3f(-size, -size, -size);
			glTexCoord2f(0.001f, 0.001f);
			glVertex3f(-size, -size, size);
			glTexCoord2f(0.001f, .999f);
			glVertex3f(size, -size, size);
		glEnd();

		//Top
		glBindTexture(GL_TEXTURE_2D, textures[POS_Y]);
		glBegin(GL_QUADS);
			glTexCoord2f(0.001f, 0.001f);
			glVertex3f(size, size, size);
			glTexCoord2f(0.001f, .999f);
			glVertex3f(-size, size, size);
			glTexCoord2f(.999f, .999f);
			glVertex3f(-size, size, -size);
			glTexCoord2f(.999f, 0.001f);
			glVertex3f(size, size, -size);
		glEnd();

		//Left
		glBindTexture(GL_TEXTURE_2D, textures[POS_X]);
		glBegin(GL_QUADS);
			glTexCoord2f(.999f, 0.001f);
			glVertex3f(-size, size, -size);
			glTexCoord2f(0.001f, 0.001f);
			glVertex3f(-size, size, size);
			glTexCoord2f(0.001f, .999f);
			glVertex3f(-size, -size, size);
			glTexCoord2f(.999f, .999f);
			glVertex3f(-size, -size, -size);
		glEnd();

		//Right
		glBindTexture(GL_TEXTURE_2D, textures[NEG_X]);
		glBegin(GL_QUADS);
			glTexCoord2f(0.001f, .999f);
			glVertex3f(size, -size, -size);
			glTexCoord2f(.999f, .999f);
			glVertex3f(size, -size, size);
			glTexCoord2f(.999f, 0.001f);
			glVertex3f(size, size, size);
			glTexCoord2f(0.001f, 0.001f);
			glVertex3f(size, size, -size);
		glEnd();
	glEndList();
}

void Skybox::update(int msDelta){}

void Skybox::draw(){
	glEnable(GL_TEXTURE_2D);
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glTranslatef(position.x, position.y, position.z);

	glDepthMask(GL_FALSE);
	glDisable(GL_BLEND);
	glDisable(GL_LIGHTING);
	glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
	glCallList(displayIndex + SKYBOX_LIST);
	glPopMatrix();
	glDepthMask(GL_TRUE);
	glEnable(GL_LIGHTING);
	glEnable(GL_BLEND);
}