#ifndef CUBEOBJECT_H
#define CUBEOBJECT_H

#include "Drawable.h"
#include "UI.h"
#include "defines.h"
#include "mat4.h"
#include <list>

class CubeObj : public Drawable{
public:
	unsigned int rotateState;
	bool hits[5];
	float speed;

	CubeObj();
	~CubeObj();
	void setup(GLuint displayIndex, GLuint textures[]);
	void update(int msDelta);
	void draw();
	void drawStrings();
	void hit(GLuint name);

private:
	std::list<std::list<bmpString>> bStrings;
	vec4f rot;
	struct Cube{
		void display(){
			GLfloat size = 5.0f;
			glBegin(GL_QUADS);
				//Back
				glNormal3f(.0f, .0f, -1.0f);
				glTexCoord2f(.001f, .001f);
				glVertex3f(-size, -size, -size);
				glTexCoord2f(.001f, .999f);
				glVertex3f(-size, size, -size);
				glTexCoord2f(.999f, .999f);
				glVertex3f(size, size, -size);
				glTexCoord2f(.999f, .001f);
				glVertex3f(size, -size, -size);

				//Front
				glNormal3f(.0f, .0f, 1.0f);
				glTexCoord2f(.001f, .001f);
				glVertex3f(-size, -size, size);
				glTexCoord2f(.999f, .001f);
				glVertex3f(size, -size, size);
				glTexCoord2f(.999f, .999f);
				glVertex3f(size, size, size);
				glTexCoord2f(.001f, .999f);
				glVertex3f(-size, size, size);

				//Bottom
				glNormal3f(.0f, -1.0f, .0f);
				glTexCoord2f(.001f, .001f);
				glVertex3f(-size, -size, -size);
				glTexCoord2f(.999f, .001f);
				glVertex3f(size, -size, -size);
				glTexCoord2f(.999f, .999f);
				glVertex3f(size, -size, size);
				glTexCoord2f(.001f, .999f);
				glVertex3f(-size, -size, size);

				//Top
				glNormal3f(.0f, 1.0f, .0f);
				glTexCoord2f(.001f, .001f);
				glVertex3f(-size, size, -size);
				glTexCoord2f(.001f, .999f);
				glVertex3f(-size, size, size);
				glTexCoord2f(.999f, .999f);
				glVertex3f(size, size, size);
				glTexCoord2f(.999f, .001f);
				glVertex3f(size, size, -size);

				//Left
				glNormal3f(-1.0f, .0f, .0f);
				glTexCoord2f(.001f, .001f);
				glVertex3f(-size, -size, -size);
				glTexCoord2f(.001f, .999f);
				glVertex3f(-size, -size, size);
				glTexCoord2f(.999f, .999f);
				glVertex3f(-size, size, size);
				glTexCoord2f(.999f, .001f);
				glVertex3f(-size, size, -size);

				//Right
				glNormal3f(1.0f, .0f, .0f);
				glTexCoord2f(.001f, .001f);
				glVertex3f(size, -size, -size);
				glTexCoord2f(.999f, .001f);
				glVertex3f(size, size, -size);
				glTexCoord2f(.999f, .999f);
				glVertex3f(size, size, size);
				glTexCoord2f(.001f, .999f);
				glVertex3f(size, -size, size);
			glEnd();
		}
	}cube;

	struct Sphere{
		GLUquadricObj *qObj;
		
		Sphere(){
			qObj = gluNewQuadric();
			gluQuadricDrawStyle(qObj, GL_FILL);
			gluQuadricNormals(qObj, GL_SMOOTH);
			gluQuadricTexture(qObj, GL_TRUE);
		}

		~Sphere(){
			gluDeleteQuadric(qObj);
		}

		void display(){
			gluSphere(qObj, 3.0f, 50, 50);
		}
	}sphere;
};

#endif //CUBEOBJECT_H