#ifndef SCENE_H
#define SCENE_H

#include "defines.h"
#include "vec4.h"
#include "mat4.h"
#include "Drawable.h"
#include "Light.h"
#include "cubeObj.h"
#include "SkyBox.h"
#include "Ground.h"
#include "Camera.h"
#include <math.h>
#include <string>
#include <gl/glut.h>
#include <gl/glext.h>

class Scene : public Drawable{
public:
	GLuint *texture;
	CubeObj *cubeObj;
	Skybox *skybox;
	Ground *ground;
	Camera *camera;
	Light mainLight;
	vec4f groundPos;

	Scene();
	~Scene();
	void draw();
	void update(int msDelta);
	void setup();
	void drawReflection();
	void loadTextures();
	void initLights();
	void initMaterials();
};
#endif //SCENE_H